import { EditorState } from "./state";
import { ChangeDesc } from "./change";
export declare class SelectionRange {
    readonly anchor: number;
    readonly head: number;
    constructor(anchor: number, head?: number);
    get from(): number;
    get to(): number;
    get empty(): boolean;
    map(mapping: ChangeDesc): SelectionRange;
    extend(from: number, to?: number): SelectionRange;
    eq(other: SelectionRange): boolean;
    toJSON(): any;
    static fromJSON(json: any): SelectionRange;
    static groupAt(state: EditorState, pos: number, bias?: 1 | -1): SelectionRange;
}
export declare class EditorSelection {
    readonly ranges: readonly SelectionRange[];
    readonly primaryIndex: number;
    constructor(ranges: readonly SelectionRange[], primaryIndex?: number);
    map(mapping: ChangeDesc): EditorSelection;
    eq(other: EditorSelection): boolean;
    get primary(): SelectionRange;
    asSingle(): EditorSelection;
    addRange(range: SelectionRange, primary?: boolean): EditorSelection;
    replaceRange(range: SelectionRange, which?: number): EditorSelection;
    toJSON(): any;
    static fromJSON(json: any): EditorSelection;
    static single(anchor: number, head?: number): EditorSelection;
    static create(ranges: readonly SelectionRange[], primaryIndex?: number): EditorSelection;
}
export declare function checkSelection(selection: EditorSelection, docLength: number): void;
//# sourceMappingURL=selection.d.ts.map